<id>
Contact Page for YaBB 2.6.0
</id>

<version>
0.4
</version>

<mod info>
Description
-----------
Adds a Contact Page to your Forum.

Installation
------------
1) Modify YaBB files using BoardMod or manually.
2) Upload modified files to your server in ASCII mode.
3) Upload ContactPageSettings.pm, ContactPage.lng and ContactPage.pm to their relevant directories in ASCII mode.
4) Upload contact.gif to yabbfiles/ModImages.

Files to edit
-------------
AdminIndex.pl
Admin/AdminSublist.pm
Admin/ModList.pm
Languages/English/Admin.lng
Languages/English/Email.lng
Languages/English/Menu.lng
Sources/AdvancedTabs.pm
Sources/SubList.pm
Sources/Subs.pm
Sources/TabMenu.pm
Templates/default/Menu.def
Variables/Settings.pm

Version History
---------------
V0.1 - First release - 16th January 2010
V0.2 - Added Spam Detection - 20th January 2010
V0.3 - Updated for YaBB 2.5 - 15th July 2010
V0.4 - Updated for 2.6.0 by Dandello - 11th July, 2014
</mod info>

<author>
Derek Barnstorm
</author>

<homepage>
http://www.yabbforumsoftware.com
</homepage>

<edit file>
AdminIndex.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
$contactpage_mod = "contactpage|$mod_list{'contact'}|$mod_list{'contact1'}|";
push @boardmod_mods, $contactpage_mod;
</add before>

<edit file>
Admin/AdminSublist.pm
</edit file>

<search for>
'cleanerrorlog','ErrorLog.pm&CleanErrorLog',
</search for>

<add after>
### Contact Page Mod Start ###
'contactpage','ContactPageSettings.pm&ContactPage',
'contactpage2','ContactPageSettings.pm&ContactPage2',
### Contact Page Mod End ###
</add after>

<edit file>
Admin/ModList.pm
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
    $contactpage_mod = qq~Contact Page|Derek Barnstorm, updated for 2.6.0 by Dandello|Adds a Contact Page to your Forum. [<span class="small"><a href="$adminurl?action=contactpage" style="font-weight: bold;">Contact Page Settings</a></span>]|0.4|11th July 2014~;
    push @installed_mods, $contactpage_mod;
</add before>

<edit file>
Languages/English/Admin.lng
</edit file>

<search for>
);

%smtp_txt = (
</search for>

<add before>
### Conatct Page Mod Start ###
'contact' => 'Contact Page Settings',
'contact1' => 'Edit Contact Page Settings',
### Contact Page Mod End ###
</add before>

<edit file>
Languages/English/Email.lng
</edit file>

<search for>
1;
</search for>

<add before>
### Contact Page Mod Start ###
$contactform = qq~<pre>Subject: {yabb contactsubject}
Name: {yabb yourname}
Email: {yabb youremail}
IP Address: {yabb contactip}
Message:
{yabb contactmessage}</pre>~;

$contactform_selfcopy = qq~<pre>Subject: {yabb contactsubject}
Name: {yabb yourname}
Email: {yabb youremail}
Message:
{yabb contactmessage}</pre>~;

$contactform_autorespond = qq~{yabb autoresponse}~;
### Contact Page Mod End ###

</add before>

<edit file>
Languages/English/Menu.lng
</edit file>

<search for>
);

%img_polltxt = (
</search for>

<add before>
'contact' => 'Contact', ### Conatct Page Mod ###
</add before>

<edit file>
Sources/AdvancedTabs.pm
</edit file>

<search for>
    $edittab{'logout'} =
      qq~<span $tabstyle>$tabfill$img_txt{'108'}$tabfill</span>~;
</search for>

<add after>
    $edittab{'contact'} = qq~<span $tabstyle>$tabfill$img_txt{'contact'}$tabfill</span>~; ### Contact Page Mod ###
</add after>

<search for>
    $texttab{'logout'}            = $img_txt{'108'};
</search for>

<add after>
    $texttab{'contact'}           = $img_txt{'contact'}; ### Contact Page Mod ###
</add after>

<edit file>
Sources/SubList.pm
</edit file>

<search for>
'collapse_cat','BoardIndex.pm&Collapse_Cat',
</search for>

<add after>
### Contact Page Mod Start ###
'contact','ContactPage.pm&Contact',
'contactsend','ContactPage.pm&ContactSend',
### Contact Page Mod End ###
</add after>

<edit file>
Sources/TabMenu.pm
</edit file>

<search for>
        $tab{'logout'} =
qq~                            <li><span |><a href="$scripturl?action=logout" title = "$img_txt{'108'}">$img_txt{'108'}</a></span></li>\n~;
    }
</search for>

<add after>
    ### Contact Page Mod Start ###
    if (-e "$vardir/ContactPage.txt") { require "$vardir/ContactPage.txt"; }
    if ($en_contactpage == 2 || (!$iamguest && $en_contactpage == 1)) {
        $tab{'contact'} = qq~<li><span |><a href="$scripturl?action=contact" title = "$img_txt{'contact'}">$tabfill$img_txt{'contact'}$tabfill</a></span></li>\n~;
    }
    ### Contact Page Mod End ###
</add after>

<edit file>
Templates/default/Menu.def
</edit file>

<search for>
collapse,collapse|img_txt|623|||imgwindowbg|png|tmp
</search for>

<add after>
contact,contact|img_txt|contact|||imgwindowbg|png|tmp
</add after>

<edit file>
Variables/Settings.pm
</edit file>

<search for>
1;
</search for>

<add before>
push @AdvancedTabs, 'contact';

</add before>

