###############################################################################
# ContactPage.pm                                                              #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Version:        YaBB 2.6.0                                                  #
# Packaged:       June 27, 2014                                               #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2014 YaBB (www.yabbforum.com) - All Rights Reserved.     #
# Software by:  The YaBB Development Team                                     #
#               with assistance from the YaBB community.                      #
###############################################################################
our $VERSION = '2.6.0';

$contactpagepmver = 'YaBB 2.6.0 $Revision: 0.4 $';
if ( $action eq 'detailedversion' ) { return 1; }

require Sources::SpamCheck;

if ( -e ("$vardir/ContactPage.txt") ) { require "$vardir/ContactPage.txt"; }

if ( $en_valimage == 2 || ( $iamguest && $en_valimage == 1 ) ) {
    require Sources::Decoder;
}

if ( !$en_contactpage || ( $iamguest && $en_contactpage != 2 ) ) {
    fatal_error('not_allowed');
}

LoadLanguage('ContactPage');

sub Contact {

    if ( !$iamguest ) {
        $contactuser =
qq~ value="${$uid.$username}{'realname'}" onfocus="txtInFields(this, '${$uid.$username}{'realname'}');" onblur="txtInFields(this, '${$uid.$username}{'realname'}')"~;
        $contactemail =
qq~ value="${$uid.$username}{'email'}" onfocus="txtInFields(this, '${$uid.$username}{'email'}');" onblur="txtInFields(this, '${$uid.$username}{'email'}')"~;
    }

    if ($contact_subjects) {
        $check_other = q~ onfocus="CheckOtherSubject();"~;
    }

    @subjectoptions = split /[|]/xsm, $contact_subjects;
    $subjectcount = 0;
    foreach (@subjectoptions) {
        $subjects .=
qq~<label for="contact_subject$subjectcount"><input type="radio" name="contact_subject" id="contact_subject$subjectcount" value="$subjectcount" />$_</label><br />\n~;
        $subjectcount++;
    }

    # SpellChecker start
    if ( $en_conspellcheck && $enable_spell_check ) {
        $yyinlinestyle .=
qq~<link href="$yyhtml_root/googiespell/googiespell.css" rel="stylesheet" type="text/css" />
<script type="text/javascript" src="$yyhtml_root/AJS.js"></script>
<script type="text/javascript" src="$yyhtml_root/googiespell/googiespell.js"></script>
<script type="text/javascript" src="$yyhtml_root/googiespell/cookiesupport.js"></script>~;
        my $userdefaultlang = ( split /-/xsm, $abbr_lang )[0];
        $userdefaultlang ||= 'en';
        $contact_spellcheck .= qq~GOOGIE_DEFAULT_LANG = '$userdefaultlang';
var googie1 = new GoogieSpell("$yyhtml_root/googiespell/", "$boardurl/Sources/SpellChecker.pl?lang=");
googie1.lang_chck_spell = '$spell_check{'chck_spell'}';
googie1.lang_revert = '$spell_check{'revert'}';
googie1.lang_close = '$spell_check{'close'}';
googie1.lang_rsm_edt = '$spell_check{'rsm_edt'}';
googie1.lang_no_error_found = '$spell_check{'no_error_found'}';
googie1.lang_no_suggestions = '$spell_check{'no_suggestions'}';
googie1.setSpellContainer("spell_container");
googie1.decorateTextarea("contact_message");~;
        $contact_spelldiv = q~<div id="spell_container"></div>~;
    }

    # SpellChecker end

    $yymain .= qq~
<form action="$scripturl?action=contactsend" method="post" name="contact" onsubmit="return CheckContactFields();">
    <div class="bordercolor" style="padding: 0px; width: 100%; margin-left: 0px; margin-right: auto;">
    <table class="tabtitle pad_4px">
        <tr>
            <th style="padding-left:1%"><img src="$yyhtml_root/ModImages/contact.gif" alt="" /> $contact_txt{'01'} $mbname </th>
        </tr>
    </table>
    <table class="bordercolor pad_4px cs_thin">
        <colgroup>
            <col width="40%" />
            <col width="60%" />
        </colgroup>
        <tr>
            <td colspan="2" class="windowbg center"> $contact_txt{'02'} </td>
        </tr><tr>
            <td class="windowbg right vtop">
                <label for="your_name"><span style="color:#f00">*</span> <span style="font-weight: bold;">$contact_txt{'03'}:</span></label>
            </td>
            <td class="windowbg">
                <input type="text" name="your_name" id="your_name" size="30" maxlength="50"$contactuser />
            </td>
        </tr><tr>
            <td class="windowbg right vtop">
                <label for="your_email"><span style="color:#f00">*</span> <span style="font-weight: bold;">$contact_txt{'04'}:</span></label>
            </td>
            <td class="windowbg">
                <input type="text" name="your_email" id="your_email" size="30" maxlength="100"$contactemail />
            </td>
        </tr><tr>
            <td class="windowbg right vtop">
                <label for="contact_subject"><span style="color:#f00">*</span> <span style="font-weight: bold;">$contact_txt{'05'}:</span></label>
            </td>
            <td class="windowbg">
                $subjects~;

    if ($contact_subjects) {
        $yymain .= qq~
                <label for="other"><input type="radio" name="contact_subject" id="other" value="other" onclick="FocusOtherSubject();" />$contact_txt{'06'}</label><br />~;
    }
    $yymain .= qq~
                <input type="text" name="other_contact_subject" id="contact_subject" size="30" maxlength="80"$check_other />
            </td>
        </tr><tr>
            <td class="windowbg right vtop">
                <label for="contact_message"><span style="color:#f00">*</span> <span style="font-weight: bold;">$contact_txt{'07'}:</span></label>
            </td>
            <td class="windowbg">
                <div style="float: left;">
                    <textarea cols="50" rows="10" name="contact_message" id="contact_message"></textarea>
                </div>
                $contact_spelldiv
                <div style="float: left; clear: both;">
                    <span class="small">$contact_txt{'08'} <input value="$MaxConMesLen" size="3" name="msgCL" class="windowbg2" style="border: 0; width: 40px; padding: 1px; font-size: 11px;" readonly="readonly" /></span>
                </div>
            </td>
        </tr>~;

    if ($en_selfcopy) {
        $yymain .= qq~<tr>
            <td class="windowbg right vtop" style="font-weight: bold;">
                <label for="contact_selfcopy">$contact_txt{'09'}</label>
            </td>
            <td class="windowbg">
                <input type="checkbox" name="contact_selfcopy" id="contact_selfcopy" />
            </td>
        </tr>~;
    }

    if ( $en_valimage == 2 || ( $iamguest && $en_valimage == 1 ) ) {
        validation_code();
        $yymain .= qq~<tr>
            <td class="windowbg right vtop">
                <label for="verification">$flood_text</label>
            </td>
            <td class="windowbg2">
            $showcheck
            </td>
        </tr><tr>
            <td class="windowbg right vtop">
                <label for="verification"><span style="color:#f00">*</span> <span style="font-weight: bold;">$floodtxt{'3'}:</span></label>
            </td>
            <td class="windowbg2">
                <input type="text" maxlength="30" name="verification" id="verification" size="30" />
            </td>
        </tr>~;

    }
    if ( -e "$langdir/$language/spam.questions"
        && ( $en_valquest == 2 || ( $iamguest && $en_valquest == 1 ) ) )
    {
        SpamQuestion();
        if ($spam_questions_case) {
            $verification_question_desc =
              qq~<br />$contact_txt{'verification_question_case'}~;
        }
        $yymain .= qq~<tr>
        <td class="windowbg right vtop">
            <label for="verification_question"><span style="color:#f00">*</span> <b>$spam_question</b><br />
            $contact_txt{'verification_question_desc'} $verification_question_desc</label>
        </td>
        <td class="windowbg2 vtop">
            <input type="text" name="verification_question" id="verification_question" size="30" maxlength="50" />
            <input type="hidden" name="verification_question_id" value="$spam_question_id" />$spam_image
        </td>
    </tr>~;

    }

    $yymain .= qq~<tr>
            <td colspan="2" class="catbg center" style="height: 50px;">
                <input type="submit" value="$contact_txt{'10'}" accesskey="s" class="button" />&nbsp;<input type="reset" value="$contact_txt{'11'}" accesskey="r" class="button" />
            </td>
        </tr>
    </table>
</form>
<script type="text/javascript">

    if (document.contact.your_name.value == '') {
        document.contact.your_name.focus();
    }~ . (
        $contact_subjects
        ? q~
    function CheckOtherSubject() {
        document.getElementById('other').checked = true;
    }
    function FocusOtherSubject() {
        if (document.getElementById('other').checked == true) {
            document.contact.other_contact_subject.focus();
        }
    }~
        : q{}
      )
      . qq~
function CheckContactFields() {
if (document.contact.your_name.value == '') {
    alert("$contact_txt{'12'}");
    document.contact.your_name.focus();
    return false;
}
if (document.contact.your_email.value == '') {
    alert("$contact_txt{'13'}");
    document.contact.your_email.focus();
    return false;
}~ . (
        $contact_subjects
        ? qq~
var subjects = 0;
for (var i=0; i < document.contact.contact_subject.length; i++) {
     if (document.contact.contact_subject[i].checked == true) {
         subjects++;
         break;
     }
}
if (subjects == 0) {
    alert("$contact_txt{'14'}");
    document.getElementById('other').checked = true
    document.contact.other_contact_subject.focus();
    return false;
}
if (document.getElementById('other').checked == true && document.contact.other_contact_subject.value == '') {
    alert("$contact_txt{'15'}");
    document.contact.other_contact_subject.focus();
    return false;
}~
        : qq~
if (document.contact.other_contact_subject.value == '') {
    alert("$contact_txt{'15'}");
    document.contact.other_contact_subject.focus();
    return false;
}~
      ) . qq~
if (document.contact.contact_message.value == '') {
    alert("$contact_txt{'16'}");
    document.contact.contact_message.focus();
    return false;
}~ . (
        $en_valquest == 2 || ( $iamguest && $en_valquest == 1 )
        ? qq~
if (document.contact.verification_question.value == '') {
    alert("$contact_txt{'17a'}");
    document.contact.verification_question.focus();
    return false;
}~
        : q{}
      )
      . (
        $en_valimage == 2 || ( $iamguest && $en_valimage == 1 )
        ? qq~
if (document.contact.verification.value == '') {
    alert("$contact_txt{'17'}");
    document.contact.verification.focus();
    return false;
}~
        : q{}
      )
      . qq~
return true;
}

var supportsKeys = false;
function tick() {
    calcCharLeft(document.forms[0]);
    if (!supportsKeys) { timerID = setTimeout("tick()", 1500); }
}
function calcCharLeft() {
clipped = false;
maxLength = $MaxConMesLen;
if (document.contact.contact_message.value.length > maxLength) {
    document.contact.contact_message.value = document.contact.contact_message.value.substring(0,maxLength);
    charleft = 0;
    clipped = true;
} else {
    charleft = maxLength - document.contact.contact_message.value.length;
}
document.contact.msgCL.value = charleft;
return clipped;
}
tick();

$contact_spellcheck
</script>~;

    $yytitle      = "$contact_txt{'01'}";
    $yynavigation = qq~&rsaquo; $contact_txt{'01'}~;
    template();
    return;
}

sub ContactSend {
    require Sources::Mailer;
    LoadLanguage('Email');

    $yourname            = $FORM{'your_name'};
    $youremail           = $FORM{'your_email'};
    $contactsubject      = $FORM{'contact_subject'};
    $othercontactsubject = $FORM{'other_contact_subject'};
    $contactmessage      = $FORM{'contact_message'};
    $contactselfcopy     = $FORM{'contact_selfcopy'};
    $yourname =~ s/\A\s+//sm;
    $yourname =~ s/\s+\Z//sm;
    $youremail =~ s/\A\s+//sm;
    $youremail =~ s/\s+\Z//sm;
    $contactsubject =~ s/\A\s+//sm;
    $contactsubject =~ s/\s+\Z//sm;
    $othercontactsubject =~ s/\A\s+//sm;
    $othercontactsubject =~ s/\s+\Z//sm;
    $contactmessage =~ s/\r(?=\n*)//gsm;
    $contact_auto =~ s/<br \/>/\n/gsm;

    $contact_email  ||= $webmaster_email;
    $selfcopy_email ||= $webmaster_email;
    $autores_email  ||= $webmaster_email;
    $selfcopy_name  ||= $mbname;
    $autores_name   ||= $mbname;
    $subject_pre    ||= "$contactpre_txt{'01'}";
    $selfcopy_pre   ||= "$contactpre_txt{'02'}";
    $autores_pre    ||= "$contactpre_txt{'03'}";

    @subjectoptions = split /[|]/xsm, $contact_subjects;

    if ( $contactsubject eq 'other' || !$contact_subjects ) {
        $subject = $othercontactsubject;
    }
    else { $subject = $subjectoptions[$contactsubject]; }

    if ( $yourname eq q{} )       { fatal_error('no_name'); }
    if ( length($yourname) > 50 ) { fatal_error('sendname_too_long'); }
    if ( $youremail eq q{} )      { fatal_error('no_email'); }
    if ( $youremail !~ /[\w\-\.\+]+\@[\w\-\.\+]+\.(\w{2,4}$)/xsm ) {
        fatal_error( 'invalid_character', "$contact_txt{'04'}." );
    }
    if ( ( $youremail =~ /(@.*@)|(\.\.)|(@\.)|(\.@)|(^\.)|(\.$)/xsm )
        || (
            $youremail !~ /^.+@\[?(\w|[-.])+\.[a-zA-Z]{2,4}|[0-9]{1,4}\]?$/xsm )
      )
    {
        fatal_error('invalid_email');
    }
    if ( length($youremail) > 100 ) { fatal_error('email_to_long'); }
    if ( $contact_subjects && $contactsubject eq q{} ) {
        fatal_error('no_subject');
    }
    if (   $contact_subjects
        && $contactsubject eq 'other'
        && $othercontactsubject eq q{} )
    {
        fatal_error('no_subject');
    }
    if ( !$contact_subjects && $othercontactsubject eq q{} ) {
        fatal_error('no_subject');
    }
    if ( $contactmessage eq q{} ) { fatal_error('no_message'); }

    # Spam detection start
    email_domain_check($youremail)
      ;    # Check if poster isn't using a distilled email domain
    my $spamdetected =
      spamcheck("$yourname $youremail $othercontactsubject $contactmessage");
    if ( !${ $uid . $FORM{$username} }{'spamcount'} ) {
        ${ $uid . $FORM{$username} }{'spamcount'} = 0;
    }
    if ( !$iamadmin && !$iamgmod && !$iammod ) {
        if ( $spamdetected == 1 ) {
            ${ $uid . $username }{'spamcount'}++;
            ${ $uid . $username }{'spamtime'} = $date;
            UserAccount( $username, 'update' );
            $spam_hits_left_count =
              $post_speed_count - ${ $uid . $username }{'spamcount'};
            if ( $spamdetected == 1 ) { fatal_error('tsc_alert'); }
        }
    }

    # Spam detection end

    if ( $en_valimage == 2 || ( $iamguest && $en_valimage == 1 ) ) {
        validation_check( $FORM{'verification'} );
    }
    if ( -e "$langdir/$language/spam.questions"
        && ( $en_valquest == 2 || ( $iamguest && $en_valquest == 1 ) ) )
    {
        SpamQuestionCheck( $FORM{'verification_question'},
            $FORM{'verification_question_id'} );
    }

    my $contact_message = template_email(
        $contactform,
        {
            'yourname'       => $yourname,
            'contactsubject' => $subject,
            'contactmessage' => $contactmessage,
            'youremail'      => $youremail,
            'contactip'      => $user_ip
        }
    );
    sendmail(
        $contact_email,   "$subject_pre: $subject",
        $contact_message, "$yourname <$youremail>"
    );

    if ( $contactselfcopy && $en_selfcopy ) {
        my $copy_message = template_email(
            $contactform_selfcopy,
            {
                'yourname'       => $yourname,
                'contactsubject' => $subject,
                'contactmessage' => $contactmessage,
                'youremail'      => $youremail
            }
        );
        sendmail(
            $youremail,    "$selfcopy_pre: $subject",
            $copy_message, "$selfcopy_name <$selfcopy_email>"
        );
    }

    if ( $en_contact_auto && $contact_auto ) {
        my $autores_message = template_email( $contactform_autorespond,
            { 'autoresponse' => $contact_auto } );
        sendmail(
            $youremail,       "$autores_pre: $subject",
            $autores_message, "$autores_name <$autores_email>"
        );
    }

    $yymain .= qq~
    <table class="tabtitle pad_4px">
        <tr>
            <th style="padding-left:1%"><img src="$yyhtml_root/ModImages/contact.gif" alt="" /> $contact_txt{'01'} $mbname </th>
        </tr>
    </table>
    <table class="bordercolor pad_4px cs_thin">
        <tr>
            <td class="windowbg center" style="padding: 20px;">
                <span style="font-weight: bold;">$contact_txt{'18'} $yourname.<br />$contact_txt{'19'}</span><br /><br />
                &bull; <a href="$scripturl">$contact_txt{'20'}</a><br /><br />
                <span class="small">$contact_txt{'21'}</span>
            </td>
        </tr>
    </table>~;

    $yyinlinestyle = qq~<meta http-equiv="refresh" content="5; url=$scripturl" />~;
    $yytitle      = "$contact_txt{'01'} - $contact_txt{'22'}";
    $yynavigation = qq~&rsaquo; $contact_txt{'01'} &rsaquo; $contact_txt{'22'}~;
    template();
    return;
}

1;
